import type { HookContext, Params } from "@feathersjs/feathers";
import type { Promisable } from "type-fest";
export declare type MethodName = "create" | "update" | "patch" | "remove";
export declare type Change<T = any> = {
    before: T;
    item: T;
};
export declare type ChangesById<T = any> = {
    [key: string]: Change<T>;
    [key: number]: Change<T>;
};
export declare type ManipulateParams = (params: Params, context: HookContext) => (Promisable<Params>);
export interface HookChangesByIdOptions {
    skipHooks: boolean;
    refetchItems: boolean;
    params?: ManipulateParams;
}
interface ViewContext<T = any> {
    item: Change<T>;
    subscription: Subscription;
    subscriptions: Subscription[];
    items: Change<T>[];
    context: HookContext;
}
export declare type CallAction<T = any> = (item: Change<T>, subscription: Subscription, items: Change<T>[], context: HookContext) => (Promisable<void>);
export declare type HookTriggerOptions = Subscription | Subscription[] | ((context: HookContext) => Promisable<Subscription | Subscription[]>);
export declare type TransformView<T = any> = undefined | ((view: Record<string, any>, viewContext: ViewContext<T>) => Promisable<Record<string, any>>) | Record<string, any>;
export declare type TransformParams = undefined | ((item: Record<string, any>, subscription: Subscription, items: Record<string, any>[], subscriptions: Subscription[]) => Promisable<Params>) | Params;
export interface Subscription {
    service?: string | string[];
    method?: string | string[];
    conditionsData?: true | Record<string, any>;
    conditionsResult?: true | Record<string, any>;
    conditionsBefore?: true | Record<string, any>;
    view?: TransformView;
    params?: TransformParams;
    isBlocking?: boolean;
    callAction: CallAction;
    [key: string]: any;
    [key: number]: any;
}
export {};
